package org.apache.bcel.classfile;

import java.io.DataOutputStream;
import java.io.IOException;

public class AnnotationElementValue extends ElementValue {
   private final AnnotationEntry annotationEntry;

   public AnnotationElementValue(int type, AnnotationEntry annotationEntry, ConstantPool cpool) {
      super(type, cpool);
      if (type != 64) {
         throw new IllegalArgumentException("Only element values of type annotation can be built with this ctor - type specified: " + type);
      } else {
         this.annotationEntry = annotationEntry;
      }
   }

   public void dump(DataOutputStream dos) throws IOException {
      dos.writeByte(super.getType());
      this.annotationEntry.dump(dos);
   }

   public AnnotationEntry getAnnotationEntry() {
      return this.annotationEntry;
   }

   public String stringifyValue() {
      return this.annotationEntry.toString();
   }

   public String toString() {
      return this.stringifyValue();
   }
}
